Bug 1374837 - /etc/init.d/network fails to unset NM_CONTROLLED
Summary: /etc/init.d/network fails to unset NM_CONTROLLED
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: initscripts
Version: 7.4
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: David Kaspar [Dee'Kej]
QA Contact: Leos Pol
Filip Hanzelka
URL:
Whiteboard:
Keywords: Patch
Depends On: 1392766
Blocks: 1380361
TreeView+ depends on / blocked
 
Reported: 2016-09-09 18:51 UTC by Bert JW Regeer (CTL)
Modified: 2017-08-02 07:37 UTC (History)
4 users (show)

(edit)
Setting "NM_CONTROLLED" now works correctly across all the `ifcfg-*` files

When the "NM_CONTROLLED=no" parameter was set for an interface in its `ifcfg-*` file, other interfaces in some cases inherited this configuration. This behaviour prevented the *NetworkManager* daemon from controlling these interfaces. The issue has now been resolved, and setting the "NM_CONTROLLED" parameter now works correctly across all the `ifcfg-*` files. As a result, the user can choose which interface is controlled by *NetworkManager*, and which is not.
Clone Of:
(edit)
Last Closed: 2017-08-01 07:29:01 UTC


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2017:2286 normal SHIPPED_LIVE initscripts bug fix and enhancement update 2017-08-01 11:26:43 UTC

Description Bert JW Regeer (CTL) 2016-09-09 18:51:24 UTC
Description of problem:

(Actually found on CentOS 7, but I have no idea if that is the right place to report it or not)

/etc/init.d/network loops over all interfaces on line 86, on line 87 it unsets some environment variables:

unset DEVICE TYPE SLAVE

However the following environment variables are set:

                eval $(LANG=C grep -F "DEVICE=" ifcfg-$i)
                eval $(LANG=C grep -F "TYPE=" ifcfg-$i)
                eval $(LANG=C grep -F "SLAVE=" ifcfg-$i)
                eval $(LANG=C grep -F "NM_CONTROLLED=" ifcfg-$i)

If you have an eth0 that sets NM_CONTROLLED to "no", and an eth1 that doesn't set NM_CONTROLLED at all, then NM_CONTROLLED will still be set to "no".

This means that all interfaces after the first one (ordered lexically) are going to not be controlled by NetworkManager...

I was dealing with some other issues, so I may or may not have actually hit a bug because of this, but figured I'd report it anyway.

Recommendation:

add NM_CONTROLLED to be unset as well.

Comment 2 Lukáš Nykrýn 2016-09-12 07:54:46 UTC
Thanks for report. Fixed in upstream https://git.fedorahosted.org/cgit/initscripts.git/commit/

We will include it in some future version of initscripts for rhel/centos7

Of course as a workaround you can explicitly set NM_CONTROLLED=yes for the other devices.

Comment 3 Lukáš Nykrýn 2016-09-12 07:55:52 UTC
Argh, here is the correct link to upstream
https://git.fedorahosted.org/cgit/initscripts.git/commit/?id=db3e951ab5333a003cfd8276437fb00a71fae334

Comment 10 errata-xmlrpc 2017-08-01 07:29:01 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2017:2286


Note You need to log in before you can comment on or make changes to this bug.